Module | ActionView::Helpers::TagHelper
In: | lib/action_view/helpers/tag_helper.rb

Provides methods to generate HTML tags programmatically when you can‘t use a Builder. By default, they output XHTML compliant tags.

### Methods

cdata_section content_tag escape_once tag

### Included Modules

ERB::Util

### Constants

BOOLEAN_ATTRIBUTES | = | %w(disabled readonly multiple checked).to_set
BLOCK_CALLED_FROM_ERB | = | 'defined? __in_erb_template'

### Public Instance methods

cdata_section(content)

Returns a CDATA section with the given `content`. CDATA sections are used to escape blocks of text containing characters which would otherwise be recognized as markup. CDATA sections begin with the string `<![CDATA[` and end with (and may not contain) the string `]]>`.

#### Examples

      cdata_section("<hello world>")
      # => <![CDATA[<hello world>]]>

      cdata_section(File.read("hello_world.txt"))
      # => <![CDATA[<hello from a text file]]>

content_tag(name, content_or_options_with_block = nil, options = nil, escape = true, &block)

Returns an HTML block tag of type `name` surrounding the `content`. Add HTML attributes by passing an attributes hash to `options`. Instead of passing the content as an argument, you can also use a block in which case, you pass your `options` as the second parameter. Set escape to false to disable attribute value escaping.

#### Options

The `options` hash is used with attributes with no value like (`disabled` and `readonly`), which you can give a value of true in the `options` hash. You can use symbols or strings for the attribute names.

#### Examples

      content_tag(:p, "Hello world!")
       # => <p>Hello world!</p>
      content_tag(:div, content_tag(:p, "Hello world!"), :class => "strong")
       # => <div class="strong"><p>Hello world!</p></div>
      content_tag("select", options, :multiple => true)
       # => <select multiple="multiple">...options...</select>

      <% content_tag :div, :class => "strong" do -%>
        Hello world!
      <% end -%>
       # => <div class="strong">Hello world!</div>

escape_once(html)

Returns an escaped version of `html` without affecting existing escaped entities.

#### Examples

      escape_once("1 < 2 &amp; 3")
      # => "1 &lt; 2 &amp; 3"

      escape_once("&lt;&lt; Accept & Checkout")
      # => "&lt;&lt; Accept &amp; Checkout"

tag(name, options = nil, open = false, escape = true)

Returns an empty HTML tag of type `name` which by default is XHTML compliant. Set `open` to true to create an open tag compatible with HTML 4.0 and below. Add HTML attributes by passing an attributes hash to `options`. Set `escape` to false to disable attribute value escaping.

#### Options

The `options` hash is used with attributes with no value like (`disabled` and `readonly`), which you can give a value of true in the `options` hash. You can use symbols or strings for the attribute names.

#### Examples

      tag("br")
      # => <br />

      tag("br", nil, true)
      # => <br>

      tag("input", { :type => 'text', :disabled => true })
      # => <input type="text" disabled="disabled" />

      tag("img", { :src => "open & shut.png" })
      # => <img src="open &amp; shut.png" />

      tag("img", { :src => "open &amp; shut.png" }, false, false)
      # => <img src="open &amp; shut.png" />

[Validate]